---
title: <semantics>
slug: Web/MathML/Element/semantics
tags:
  - MathML
  - MathML Reference
  - 'MathML:Element'
---
<div>{{MathMLRef}}</div>

<p class="summary">In MathML there are two ways to mark up mathematics: <em>Presentation</em> MathML is used to control the layout of equations, whereas <em>Content</em> MathML is designed to encode the semantic mathematical meaning and to make expressions understandable to computer algebra systems. The MathML elements <code>&lt;semantics&gt;</code>, <code>&lt;annotation&gt;</code> and <code>&lt;annotation-xml&gt;</code> are used to combine presentation and content markup and to provide both, layout information and semantic meaning of mathematical expressions.</p>

<p>The <code>&lt;semantics&gt;</code> element acts as a container element associating annotations and must have child elements (it will raise an <em>invalid markup </em>error otherwise). The <code>&lt;annotation&gt;</code> element is the container element containing semantic information in a non-XML format, whereas the <code>&lt;annotation-xml&gt;</code> element contains content in an XML format, e.g. Content MathML or OpenMath.</p>

<p>The rules of determining the visible child in a <code>&lt;semantics&gt;</code> element are the following:</p>

<ul>
 <li>If no rule other rule applies: By default only the first child is rendered, which is supposed to be presentation markup.</li>
 <li>If the first child is a presentation MathML element other than <code>&lt;annotation&gt;</code> or <code>&lt;annotation-xml&gt;</code>, render the first child.</li>
 <li>If no Presentation MathML is found, render the first <code>&lt;annotation&gt;</code> or <code>&lt;annotation-xml&gt;</code> child element of <code>&lt;semantics&gt;</code>.<br>
  Beware that <code>&lt;annotation-xml&gt;</code> elements are only recognized, if the encoding attribute is set to one of the following:
  <ul>
   <li><code><span class="s">"application/mathml-presentation+xml</span></code>"</li>
   <li><code><span class="s">"MathML-Presentation</span></code>"</li>
   <li><span class="s"><code>"SVG1.1</code></span>"</li>
   <li><code>"text/html"</code></li>
   <li><code>"image/svg+xml"</code></li>
   <li><code><span class="st">"application/xml</span></code>".</li>
  </ul>
  Note that <span class="c">"application/mathml+xml</span>" is <em>not</em> mentioned here as it does not distinguish between Content or Presentation MathML.</li>
</ul>

<h2 id="Attributes">Attributes</h2>

<p>The following attributes can be set on <code>&lt;annotation&gt;</code> and <code>&lt;annotation-xml&gt;</code>:</p>

<dl>
 <dt id="attr-definitionurl">definitionURL</dt>
 <dd>The location of the annotation key symbol.</dd>
 <dt id="attr-displaystyle"><code>displaystyle</code></dt>
 <dd>A Boolean value specifying whether more vertical space is used for displayed equations or, if set to <code>false</code>, a more compact layout is used to display formulas. The main effect is that larger versions of operators are displayed, when <code>displaystyle</code> is set to <code>true</code>. See also <code>largeop</code> and <code>movablelimits</code> on {{ MathMLElement("mo") }}.</dd>
 <dt id="attr-encoding">encoding</dt>
 <dd>The encoding of the semantic information in the annotation (e.g. "MathML-Content", "MathML-Presentation", "application/openmath+xml", "image/png")</dd>
 <dt id="attr-cd">cd</dt>
 <dd>The content dictionary that contains the annotation key symbol.</dd>
 <dt id="attr-name">name</dt>
 <dd>The name of the annotation key symbol.</dd>
 <dt id="attr-src">src</dt>
 <dd>The location of an external source for semantic information.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: html notranslate">&lt;math&gt;
  &lt;semantics&gt;

    &lt;!-- Presentation MathML --&gt;
    &lt;mrow&gt;
      &lt;msup&gt;
        &lt;mi&gt;x&lt;/mi&gt;
        &lt;mn&gt;2&lt;/mn&gt;
      &lt;/msup&gt;
      &lt;mo&gt;+&lt;/mo&gt;
      &lt;mi&gt;y&lt;/mi&gt;
    &lt;/mrow&gt;

    &lt;!-- Content MathML --&gt;
    &lt;annotation-xml encoding="MathML-Content"&gt;
      &lt;apply&gt;
        &lt;plus/&gt;
        &lt;apply&gt;
          &lt;power/&gt;
          &lt;ci&gt;x&lt;/ci&gt;
          &lt;cn type="integer"&gt;2&lt;/cn&gt;
        &lt;/apply&gt;
        &lt;ci&gt;y&lt;/ci&gt;
      &lt;/apply&gt;
    &lt;/annotation-xml&gt;

    &lt;!-- annotate an image --&gt;
    &lt;annotation encoding="image/png" src="some/path/formula.png"/&gt;

    &lt;!-- annotate TeX --&gt;
    &lt;annotation encoding="application/x-tex"&gt;
      x^{2} + y
    &lt;/annotation&gt;

  &lt;/semantics&gt;
&lt;/math&gt;</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("MathMLCore", "#semantics-and-presentation", "semantics")}}</td>
   <td>{{Spec2("MathMLCore")}}</td>
   <td>Draft specification</td>
  </tr>
  <tr>
   <td>{{ SpecName('MathML3', 'chapter5.html', 'Mixing Markup Languages for Mathematical Expressions') }}</td>
   <td>{{ Spec2('MathML3') }}</td>
   <td>Current specification</td>
  </tr>
  <tr>
   <td>{{ SpecName('MathML2', 'chapter5.html', 'Combining Presentation and Content Markup ') }}</td>
   <td>{{ Spec2('MathML2') }}</td>
   <td>Initial specification</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("mathml.elements.semantics")}}</p>

<h2 id="Gecko-specific_notes">Gecko-specific notes</h2>

<ul>
 <li>The algorithm of determining the visible child in <code>&lt;semantics&gt;</code> has been corrected in {{geckoRelease("23")}} to match the MathML specification. In prior versions the first child element has been rendered.</li>
 <li>In Gecko <code>&lt;annotation&gt;</code> and <code>&lt;annotation-xml&gt;</code> elements are ignored if the <code>src</code> attribute is set.</li>
</ul>
